## Index

- `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operations` (interface)
- `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.CancelOperationRequest` (message)
- `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.GetOperationRequest` (message)
- `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.ListOperationsRequest` (message)
- `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.ListOperationsResponse` (message)
- `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operation` (message)

## Operations

Manages long-running operations with an API service.

When an API method normally takes long time to complete, it can be designed to return `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operation` to the client, and the client can use this interface to receive the real response asynchronously by polling the operation resource, or pass the operation resource to another API (such as Pub/Sub API) to receive the response. Any API service that returns long-running operations should implement the `Operations` interface so developers can have a consistent client experience.

| CancelOperation |
|---|
| `` rpc CancelOperation(`https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.CancelOperationRequest`) returns (`https://protobuf.dev/reference/protobuf/google.protobuf#empty`) `` Cancels a transfer. Use the `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operations.GetOperation` method to check if the cancellation succeeded or if the operation completed despite the `cancel` request. When you cancel an operation, the currently running transfer is interrupted. For recurring transfer jobs, the next instance of the transfer job will still run. For example, if your job is configured to run every day at 1pm and you cancel Monday's operation at 1:05pm, Monday's transfer will stop. However, a transfer job will still be attempted on Tuesday. This applies only to currently running operations. If an operation is not currently running, `cancel` does nothing. <br /> > [!CAUTION] > **Caution:** Canceling a transfer job can leave your data in an unknown state. We recommend that you restore the state at both the destination and the source after the `cancel` request completes so that your data is in a consistent state. <br /> When you cancel a job, the next job computes a delta of files and may repair any inconsistent state. For instance, if you run a job every day, and today's job found 10 new files and transferred five files before you canceled the job, tomorrow's transfer operation will compute a new delta with the five files that were not copied today plus any new files discovered tomorrow. Authorization scopes :   Requires the following OAuth scope: - `https://www.googleapis.com/auth/cloud-platform` For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp). |

| GetOperation |
|---|
| `` rpc GetOperation(`https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.GetOperationRequest`) returns (`https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operation`) `` Gets the latest state of a long-running operation. Clients can use this method to poll the operation result at intervals as recommended by the API service. Authorization scopes :   Requires the following OAuth scope: - `https://www.googleapis.com/auth/cloud-platform` For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp). |

| ListOperations |
|---|
| `` rpc ListOperations(`https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.ListOperationsRequest`) returns (`https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.ListOperationsResponse`) `` Lists transfer operations. Operations are ordered by their creation time in reverse chronological order. Authorization scopes :   Requires the following OAuth scope: - `https://www.googleapis.com/auth/cloud-platform` For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp). |

## CancelOperationRequest

The request message for `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operations.CancelOperation`.

| Fields ||
|---|---|
| `name` | `string` The name of the operation resource to be cancelled. |

## GetOperationRequest

The request message for `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operations.GetOperation`.

| Fields ||
|---|---|
| `name` | `string` The name of the operation resource. |

## ListOperationsRequest

The request message for `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operations.ListOperations`.

| Fields ||
|---|---|
| `name` | `string` Required. The name of the type being listed; must be `transferOperations`. |
| `filter` | `string` Required. A list of query parameters specified as JSON text in the form of: `{"projectId":"my_project_id", "jobNames":["jobid1","jobid2",...], "jobNamePattern": "job_name_pattern", "operationNames":["opid1","opid2",...], "operationNamePattern": "operation_name_pattern", "minCreationTime": "min_creation_time", "maxCreationTime": "max_creation_time", "transferStatuses":["status1","status2",...]}` Since `jobNames`, `operationNames`, and `transferStatuses` support multiple values, they must be specified with array notation. `projectId` is the only argument that is required. If specified, `jobNamePattern` and `operationNamePattern` must match the full job or operation name respectively. '\*' is a wildcard matching 0 or more characters. `minCreationTime` and `maxCreationTime` should be timestamps encoded as a string in the [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. The valid values for `transferStatuses` are case-insensitive: `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.storagetransfer.v1#google.storagetransfer.v1.TransferOperation.Status.ENUM_VALUES.google.storagetransfer.v1.TransferOperation.Status.IN_PROGRESS`, `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.storagetransfer.v1#google.storagetransfer.v1.TransferOperation.Status.ENUM_VALUES.google.storagetransfer.v1.TransferOperation.Status.PAUSED`, `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.storagetransfer.v1#google.storagetransfer.v1.TransferOperation.Status.ENUM_VALUES.google.storagetransfer.v1.TransferOperation.Status.SUCCESS`, `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.storagetransfer.v1#google.storagetransfer.v1.TransferOperation.Status.ENUM_VALUES.google.storagetransfer.v1.TransferOperation.Status.FAILED`, and `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.storagetransfer.v1#google.storagetransfer.v1.TransferOperation.Status.ENUM_VALUES.google.storagetransfer.v1.TransferOperation.Status.ABORTED`. |
| `page_size` | `int32` The list page size. The max allowed value is 256. |
| `page_token` | `string` The list page token. |
| `return_partial_success` | `bool` When set to `true`, operations that are reachable are returned as normal, and those that are unreachable are returned in the `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.ListOperationsResponse.FIELDS.repeated.string.google.longrunning.ListOperationsResponse.unreachable` field. This can only be `true` when reading across collections. For example, when `parent` is set to `"projects/example/locations/-"`. This field is not supported by default and will result in an `UNIMPLEMENTED` error if set unless explicitly documented otherwise in service or product specific documentation. |

## ListOperationsResponse

The response message for `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operations.ListOperations`.

| Fields ||
|---|---|
| `operations[]` | `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operation` A list of operations that matches the specified filter in the request. |
| `next_page_token` | `string` The standard List next-page token. |
| `unreachable[]` | `string` Unordered list. Unreachable resources. Populated when the request sets `ListOperationsRequest.return_partial_success` and reads across collections. For example, when attempting to list all resources across all supported locations. |

## Operation

This resource represents a long-running operation that is the result of a network API call.

| Fields ||
|---|---|
| `name` | `string` The server-assigned unique name. The format of `name` is `transferOperations/some/unique/name`. |
| `metadata` | `https://protobuf.dev/reference/protobuf/google.protobuf#any` Represents the transfer operation object. To request a `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.storagetransfer.v1#google.storagetransfer.v1.TransferOperation` object, use `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.longrunning#google.longrunning.Operations.GetOperation`. |
| `done` | `bool` If the value is `false`, it means the operation is still in progress. If `true`, the operation is completed, and either `error` or `response` is available. |
| Union field `result`. The operation result, which can be either an `error` or a valid `response`. If `done` == `false`, neither `error` nor `response` is set. If `done` == `true`, exactly one of `error` or `response` can be set. Some services might not provide the result. `result` can be only one of the following: ||
| `error` | `https://docs.cloud.google.com/storage-transfer/docs/reference/rpc/google.rpc#google.rpc.Status` The error result of the operation in case of failure or cancellation. |
| `response` | `https://protobuf.dev/reference/protobuf/google.protobuf#any` The normal, successful response of the operation. If the original method returns no data on success, such as `Delete`, the response is `google.protobuf.Empty`. If the original method is standard `Get`/`Create`/`Update`, the response should be the resource. For other methods, the response should have the type `XxxResponse`, where `Xxx` is the original method name. For example, if the original method name is `TakeSnapshot()`, the inferred response type is `TakeSnapshotResponse`. |